package escape;

import java.awt.*;

public class ConnectMode extends GameMode {
  
  public static final int FRAMES = 180;
  public static final int DELAY = 90;
  
  public static final int MAGNET_X1 = 800;
  public static final int MAGNET_X2 = 250;
  public static final int MAGNET_Y = 241;
  
  public static final int LACE1_X1 = -500;
  public static final int LACE1_X2 = 0;
  public static final int LACE1_Y = 312;
  
  public static final int LACE2_X = -203;
  public static final int LACE2_Y = 316;
  
  public static final float MAGNET_VX = (MAGNET_X2 - MAGNET_X1) / (float)FRAMES;
  public static final float LACE1_VX = (LACE1_X2 - LACE1_X1) / (float)FRAMES;

  private boolean delayMode;
  private float magnetX = MAGNET_X1;
  private float laceX = LACE1_X1;
  private int frames;
  private int delay;

  @Override
  public void modify() {
    if (delayMode) {
      if (++delay == DELAY) {
        addToInventory(Images.magnets[2]);
        main.popMode();
      }
    } else {
      magnetX += MAGNET_VX;
      laceX += LACE1_VX;
      if (++frames == FRAMES) {
        delayMode = true;
      }
    }
  }

  @Override
  public void draw(Graphics2D g) {
    g.setColor(Color.WHITE);
    g.fillRect(0, 80, 800, 600);

    if (delayMode) {
      g.drawImage(Images.magnets[1], MAGNET_X2, MAGNET_Y, null);
      g.drawImage(Images.shoeLaces[2], LACE2_X, LACE2_Y, null);
    } else {
      g.drawImage(Images.magnets[1], (int)magnetX, MAGNET_Y, null);
      g.drawImage(Images.shoeLaces[1], (int)laceX, LACE1_Y, null);
    }
  }

  @Override
  public boolean isInventoryAccessible() {
    return false;
  }
}
