package escape;

import java.awt.*;
import java.awt.image.BufferedImage;

public class DrainMode extends GameMode {

  public static final int REGION_LEFT = 100;
  public static final int REGION_RIGHT_UP = 101;
  public static final int REGION_RIGHT_DOWN = 102;
  public static final int REGION_UP_LEFT = 103;
  public static final int REGION_UP_RIGHT = 104;
  public static final int REGION_DOWN = 105;

  public DrainMode() {
    addClickRegions();
  }

  private void addClickRegions() {
    clickRegions.add(new Region(0, 80, 100, 520, REGION_LEFT,
        Images.arrowCursors[Images.LEFT]));
    clickRegions.add(new Region(700, 80, 100, 260, REGION_RIGHT_UP,
        Images.arrowCursors[Images.RIGHT]));
    clickRegions.add(new Region(700, 340, 100, 260, REGION_RIGHT_DOWN,
        Images.arrowCursors[Images.RIGHT]));
    clickRegions.add(new Region(100, 80, 300, 100, REGION_UP_LEFT,
        Images.arrowCursors[Images.UP]));
    clickRegions.add(new Region(390, 80, 300, 100, REGION_UP_RIGHT,
        Images.arrowCursors[Images.UP]));
    clickRegions.add(new Region(100, 500, 600, 100, REGION_DOWN,
        Images.arrowCursors[Images.DOWN]));
  }

  @Override
  public void modify() {
  }

  @Override
  public void draw(Graphics2D g) {
    g.setColor(Color.WHITE);
    g.fillRect(0, 80, 800, 600);

    g.drawImage(Images.drain, 337, 289, null);
  }

  @Override
  public void inventoryItemLifted(BufferedImage image) {
    if (image == Images.magnets[2]) {
      dropRegions.add(new Region(337, 298, 127, 121));
    }
  }

  @Override
  public void regionDropped(BufferedImage image, Region dropRegion) {
    if (image == Images.magnets[2]) {
      main.setMode(main.drainMagnetMode);
    }
  }

  @Override
  public void regionClicked(Region clickRegion) {
    if (clickRegion.id == REGION_LEFT) {
      main.setMode(main.closetMode);
    } else if (clickRegion.id == REGION_RIGHT_UP) {
      main.setMode(main.trashCanMode);
    } else if (clickRegion.id == REGION_RIGHT_DOWN) {
      main.setMode(main.doorMode);
    } else if (clickRegion.id == REGION_DOWN) {
      main.setMode(main.stallsMode);
    } else if (clickRegion.id == REGION_UP_LEFT) {
      if (GameState.solvedUrinalPuzzle) {
        main.setMode(main.pipesMode);
      } else {
        main.setMode(main.urinalMode);
      }
    } else if (clickRegion.id == REGION_UP_RIGHT) {
      main.setMode(main.sinksMode);
    } else if (!GameState.openedSmokeAlarm) {
      GameState.openedSmokeAlarm = true;
    } else if (!GameState.removedBattery) {
      GameState.removedBattery = true;
      addToInventory(Images.battery);
    }
    addClickRegions();
  }
}
