package escape;

import java.awt.image.*;
import java.util.*;

public final class GameState {

  public static BufferedImage[] inventory = new BufferedImage[10];

  public static long startTime = System.currentTimeMillis();
  public static int[] lockCombination = new int[6];
  public static String entryCode;
  public static String[] encryptedCodes = new String[2];
  public static char[] mapping = new char[256];
  public static String[] conversions = new String[10];
  public static int messageSinkIndex;
  public static int lockedStallIndex;
  public static int toiletPaperStallIndex;
  public static int plungerStallIndex;
  public static int doorsOpened;

  public static boolean ventCoverRemoved;
  public static boolean acquiredPenny;
  public static boolean acquiredKeycard;
  public static boolean keycardUsed;
  public static boolean turnedCrank;
  public static boolean acquiredPaperTowel;
  public static boolean openedSmokeAlarm;
  public static boolean removedBattery;
  public static boolean tilePuzzleSolved;
  public static boolean acquiredBottle;
  public static boolean liftedMat;
  public static boolean acquiredScrewdriver;
  public static boolean acquiredPrintout;
  public static boolean solvedUrinalPuzzle;
  public static boolean shatteredMirror;
  public static boolean stallUnlocked;
  public static boolean killedToiletCreature;
  public static boolean acquiredTooth;
  public static boolean acquiredShoelace;
  public static boolean unrolledToiletPaper;
  public static boolean acquiredToiletPaper;
  public static boolean batteryInstalled;
  public static boolean passwordEntered;
  public static boolean plungerSwitched;
  public static boolean acquiredMagnet;
  public static boolean doorUnlocked;
  public static boolean doorOpened;

  static {

    ArrayList<Integer> digits = new ArrayList<Integer>();
    for(int i = 0; i < 10; i++) {
      digits.add(i);
    }
    entryCode = "";
    for(int i = 0; i < 8; i++) {
      entryCode += Integer.toString(digits.remove(
          GameMode.random.nextInt(digits.size())));
    }
    ArrayList<Character> list = new ArrayList<Character>();
    for(int i = 0; i < 26; i++) {
      list.add((char)('A' + i));
    }
    ArrayList<String> conversionsList = new ArrayList<String>();
    for(int i = 0; i < 10; i++) {
      char c = list.remove(GameMode.random.nextInt(list.size()));
      mapping['0' + i] = c;
      mapping[c] = (char)('0' + i);
      conversionsList.add(String.format("%c = %c", c, (char)('0' + i)));
    }
    for(int i = 0; i < 10; i++) {
      conversions[i] = conversionsList.remove(
          GameMode.random.nextInt(conversionsList.size()));
    }
    String encryptedCode = "";
    for(int i = 0; i < entryCode.length(); i++) {
      encryptedCode += mapping[entryCode.charAt(i)];
    }
    ArrayList<Integer> hides = new ArrayList<Integer>();
    ArrayList<Integer> hides2 = new ArrayList<Integer>();
    for(int i = 0; i < 8; i++) {
      hides.add(i);
    }
    for(int i = 0; i < 4; i++) {
      hides2.add(hides.remove(GameMode.random.nextInt(hides.size())));
    }
    StringBuilder sb1 = new StringBuilder(encryptedCode);
    StringBuilder sb2 = new StringBuilder(encryptedCode);
    for(int i = 0; i < 4; i++) {
      sb1.setCharAt(hides.get(i), '?');
      sb2.setCharAt(hides2.get(i), '?');
    }
    encryptedCodes[0] = sb1.toString();
    encryptedCodes[1] = sb2.toString();

    messageSinkIndex = GameMode.random.nextInt(3);

    ArrayList<Integer> stalls = new ArrayList<Integer>();
    for(int i = 0; i < 3; i++) {
      stalls.add(i);
    }
    lockedStallIndex = stalls.remove(GameMode.random.nextInt(stalls.size()));
    toiletPaperStallIndex = stalls.remove(
        GameMode.random.nextInt(stalls.size()));
    plungerStallIndex = stalls.remove(GameMode.random.nextInt(stalls.size()));

    for(int i = 0; i < 6; i++) {
      do {
        lockCombination[i] = GameMode.random.nextInt(5);
      } while(i > 0 && lockCombination[i - 1] == lockCombination[i]);
    }
  }

  private GameState() {
  }
}
