package escape;

import java.awt.Graphics2D;

public class KeyholeMode extends GameMode {

  public int y;
  public int delay;

  public KeyholeMode() {
    reset();
  }

  public void reset() {
    y = 0;
    delay = 0;
  }

  @Override
  public void modify() {
    if (y < 520) {
      y++;
    } else if (++delay > 30) {
      Main.main.setMode(Main.main.doorMode);
    }
  }

  @Override
  public void draw(Graphics2D g) {
    g.setClip(0, 80, 800, 520);
    g.drawImage(Images.keyholeBackground, 0, 80 - y, null);
    g.drawImage(Images.keyholeForeground, 0, 275 - (y << 1), null);
    g.setClip(null);
  }

  @Override
  public boolean isInventoryAccessible() {
    return false;
  }
}
