package escape;

import java.awt.*;

public class SinksMode extends GameMode {
  
  public static final int LEFT_REGION = 0;
  public static final int RIGHT_REGION = 1;
  public static final int UP_REGION = 2;
  public static final int DOWN_REGION = 3;

  public static final int LEFT_SINK_REGION = 4;
  public static final int MIDDLE_SINK_REGION = 5;
  public static final int RIGHT_SINK_REGION = 6;

  public static final int SHATTERED_REGION = 7;

  public SinksMode() {
    addClickRegions();
  }

  private void addClickRegions() {
    clickRegions.add(new Region(0, 80, 40, 520, LEFT_REGION,
        Images.arrowCursors[Images.LEFT]));
    clickRegions.add(new Region(740, 80, 60, 520, RIGHT_REGION,
        Images.arrowCursors[Images.RIGHT]));
    clickRegions.add(new Region(40, 80, 700, 100, UP_REGION,
        Images.arrowCursors[Images.UP]));
    clickRegions.add(new Region(40, 520, 700, 80, DOWN_REGION,
        Images.arrowCursors[Images.DOWN]));

    clickRegions.add(new Region(102, 361, 119, 90, LEFT_SINK_REGION));
    clickRegions.add(new Region(331, 367, 119, 90, MIDDLE_SINK_REGION));
    clickRegions.add(new Region(577, 365, 119, 90, RIGHT_SINK_REGION));

    if (GameState.shatteredMirror) {
      clickRegions.add(new Region(GameState.messageSinkIndex == 0 ? 122
            : GameState.messageSinkIndex == 1 ? 351
            : 597, 231, 40, 26, SHATTERED_REGION));
    }
  }

  @Override
  public void modify() {
  }

  @Override
  public void draw(Graphics2D g) {
    g.drawImage(Images.sinks, 0, 80, null);

    if (GameState.shatteredMirror) {
      g.drawImage(Images.mirrorHoles[2],
          GameState.messageSinkIndex == 0 ? 122
              : GameState.messageSinkIndex == 1 ? 351
              : 597, 231, null);
    }
  }

  @Override
  public void regionClicked(Region clickRegion) {
    if (clickRegion.id == SHATTERED_REGION) {
      main.pushMode(main.mirrorHoleMode);
    } else if (clickRegion.id == LEFT_SINK_REGION) {
      main.mirrorMode.setHiddenMessageMirror(GameState.messageSinkIndex == 0);
      main.setMode(main.mirrorMode);
    } else if (clickRegion.id == MIDDLE_SINK_REGION) {
      main.mirrorMode.setHiddenMessageMirror(GameState.messageSinkIndex == 1);
      main.setMode(main.mirrorMode);
    } else if (clickRegion.id == RIGHT_SINK_REGION) {
      main.mirrorMode.setHiddenMessageMirror(GameState.messageSinkIndex == 2);
      main.setMode(main.mirrorMode);
    } else if (clickRegion.id == LEFT_REGION) {
      if (GameState.solvedUrinalPuzzle) {
        main.setMode(main.pipesMode);
      } else {
        main.setMode(main.urinalMode);
      }
    } else if (clickRegion.id == RIGHT_REGION) {
      main.setMode(main.trashCanMode);
    } else if (clickRegion.id == UP_REGION) {
      main.setMode(main.smokeAlarmMode);
    } else if (clickRegion.id == DOWN_REGION) {
      main.setMode(main.drainMode);
    }
    addClickRegions();
  }

  @Override
  public void enter() {
    super.enter();
    clickRegions.clear();
    addClickRegions();
  }
}
