package escape;

import java.awt.*;

public class SmokeAlarmMode extends GameMode {

  public static final int REGION_LEFT = 100;
  public static final int REGION_RIGHT_UP = 101;
  public static final int REGION_RIGHT_DOWN = 102;
  public static final int REGION_UP = 103;
  public static final int REGION_DOWN_LEFT = 104;
  public static final int REGION_DOWN_RIGHT = 105;

  public SmokeAlarmMode() {
    addClickRegions();
  }

  @Override
  public void modify() {
  }

  private void addClickRegions() {
    if (!GameState.removedBattery) {
      if (GameState.openedSmokeAlarm) {
        clickRegions.add(new Region(369, 330, 42, 28));
      } else {
        clickRegions.add(new Region(356, 299, 88, 85));
      }
    }

    clickRegions.add(new Region(0, 80, 100, 520, REGION_LEFT,
        Images.arrowCursors[Images.LEFT]));
    clickRegions.add(new Region(700, 80, 100, 260, REGION_RIGHT_UP,
        Images.arrowCursors[Images.RIGHT]));
    clickRegions.add(new Region(700, 340, 100, 260, REGION_RIGHT_DOWN,
        Images.arrowCursors[Images.RIGHT]));
    clickRegions.add(new Region(100, 80, 600, 100, REGION_UP,
        Images.arrowCursors[Images.UP]));
    clickRegions.add(new Region(100, 500, 300, 100, REGION_DOWN_LEFT,
        Images.arrowCursors[Images.DOWN]));
    clickRegions.add(new Region(390, 500, 300, 100, REGION_DOWN_RIGHT,
        Images.arrowCursors[Images.DOWN]));
  }

  @Override
  public void draw(Graphics2D g) {
    g.setColor(Color.WHITE);
    g.fillRect(0, 80, 800, 600);

    if (GameState.removedBattery) {
      g.drawImage(Images.smokeAlarms[2], 335, 280, null);
    } else if (GameState.openedSmokeAlarm) {
      g.drawImage(Images.smokeAlarms[1], 335, 280, null);
    } else {
      g.drawImage(Images.smokeAlarms[0], 335, 280, null);
    }
  }

  @Override
  public void regionClicked(Region clickRegion) {
    if (clickRegion.id == REGION_LEFT) {
      main.setMode(main.closetMode);
    } else if (clickRegion.id == REGION_RIGHT_UP) {
      main.setMode(main.trashCanMode);
    } else if (clickRegion.id == REGION_RIGHT_DOWN) {
      main.setMode(main.doorMode);
    } else if (clickRegion.id == REGION_UP) {
      main.setMode(main.stallsMode);
    } else if (clickRegion.id == REGION_DOWN_LEFT) {
      if (GameState.solvedUrinalPuzzle) {
        main.setMode(main.pipesMode);
      } else {
        main.setMode(main.urinalMode);
      }
    } else if (clickRegion.id == REGION_DOWN_RIGHT) {
      main.setMode(main.sinksMode);
    } else if (!GameState.openedSmokeAlarm) {
      GameState.openedSmokeAlarm = true;
    } else if (!GameState.removedBattery) {
      GameState.removedBattery = true;
      addToInventory(Images.battery);
    }
    addClickRegions();
  }
}
