package escape;

import java.awt.*;

public class TitleMode implements IMode {

  public static final String TITLE = "ESCAPE THE MEN'S ROOM";
  public static final int OFFSET_X = (800 - TITLE.length() * 25) / 2;
  public static final int OFFSET_Y = (600 - 25) / 2;

  public boolean cursorVisible;
  public int blinkDelay = 1;
  public StringBuilder sb = new StringBuilder(" ");
  public int blinks;
  public int typeDelay = 1;
  public int titleIndex = 0;
  public int finishDelay = 0;

  @Override
  public void update() {
    if (--blinkDelay == 0) {
      blinks++;
      blinkDelay = 30;
      cursorVisible = !cursorVisible;
      sb.setCharAt(sb.length() - 1, cursorVisible ? '_' : ' ');
    }
    if (blinks > 6) {
      if (titleIndex < TITLE.length()) {
        if (--typeDelay == 0) {
          typeDelay = 1 + GameMode.random.nextInt(31);
          sb.setLength(sb.length() - 1);
          sb.append(TITLE.charAt(titleIndex++));
          sb.append(cursorVisible ? '_' : ' ');
        }
      } else if (++finishDelay >= 180) {
        Main.main.setMode(Main.main.doorMode);
      }
    }
  }

  @Override
  public void render(Graphics2D g) {
    g.setColor(Color.WHITE);
    g.fillRect(0, 0, 800, 600);

    Images.drawString(g, sb, OFFSET_X, OFFSET_Y);
  }

  @Override
  public void enter() {
  }
}
